#ifdef vxWorks
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>
#include <vxWorks.h>
#include <timexLib.h>
#include <ioLib.h>
#include "taskLib.h"
#include "moduleLib.h"
#include "loadLib.h"
#include "fast_lock.h"
#endif	/* vxWorks */

#ifdef UNIX
#define INCLsemLibh
#define INCLvxLibh
#endif	/* UNIX */

/* TINE includes */
#include "stdio.h" 
#include "prolog.h"
#include "rpctypes.h"
#include "errors.h"
#include "database.h"
#include "almsrv.h"
#include "toolkit.h"
#include "servdef.h"

#include "dbAccess.h"
#include "dbStaticLib.h"
#include "cvtFast.h"

typedef struct
{
  int severity;
  int code;
  int system;
  char tag[16];
  char text[40];
  char url[40];
} E2T_ALARM_XREF;
#define USR_ALARM_OFFSET 512

extern struct dbBase *pdbbase;
#define DZK(c)   if(verboseTINE) {c}
long verboseTINE = 0;

#define MAXLINE 80
typedef struct {		/* line output structure */
    char            out_buff[MAXLINE + 1];
    char           *pNext;
    char           *pLast;
    char           *pNexTab;
    char            message[128];
} TAB_BUFFER;

#ifndef MIN
#define MIN(x,y)        ((x < y)?x:y)
#endif
#ifndef MAX
#define MAX(x,y)        ((x > y)?x:y)
#endif

/* Defines */
#define CONFIG_FILE	"e2t.cfg"
#define TINE_FREE_PROPERTIES	5

/* Prototypes */
long tineGetNumRecords();
long tineGetRecords(NAME32 *pname);
long tineGetRecords();

long tineGetRecordNamesAndTypes();

void tineTest();
long tineGetRecordTypes();
int  tineGetFieldValue(char *pname, char *pprop, void *ptr, int tineFmt, int len, int *pCount);
int tineGetAlarmLimits(char *recName, E2T_ALARM_XREF *pThr);
int tineSetAlarm(char *chname,int sev,int status,float fval);


long tinePutFieldValue(char *pname,char *pvalue);
short getTINEformat(int epicsFmt);

void KeepTineSrvAlive();
int GetDataBaseSize(char *filename);
int findcol(char *str,char *tag);
char *colptr(int col,char *str);
void startE2T();

typedef struct devChainStruct
{
  char name[16];
  struct devChainStruct *next;
} devChain;

typedef struct {
  char  name[32];
  char  desc[96];
  char separater[2];
  devChain *devs;
  short fmt;
  short elem;
  int ndev;
} Tproperty;

typedef struct {
  char devName[32];
  char devProperty[32];
  int  prpLength;
  int  prpFormat;
  char prpDesc[32];
  int  numCmpPrps;
  NAME32 *cmpPrps;
  NAME32 *cmpDevPrps;
  NAME32 *cmpDevs;
  NAME16 *cmpAliasDevs;
  NAME32 *cmpDesc;
} COMPOSITE;

int readStructureFile( char *filename, NAME32 **cmpPrps, NAME32 **cmpDevPrps, NAME32 **cmpDevs, NAME16 **cmpAliasDevs, NAME32 **cmpDesc, int *numCmpProperties);
int readCompositeFile(char *cmpFileName);
int fillDeviceNamesAndProperties(char *fec,char *server,NAME32 **devnames,int *numDevices,Tproperty **prp,int *numProperties);
int gtweqm(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access);
int E2T();


